#include "StdAfx.h"
#include <vcclr.h>
#include "CommandInterface.h"

CCommandInterface::CCommandInterface(CallbackPointer callbackPointerParam) :
	callbackPointer(callbackPointerParam)
{ 

}

void CCommandInterface::Send(System::String^ command)
{
	cli::pin_ptr<const System::Char> pCommandChar = PtrToStringChars( command );
	const wchar_t *pszpCommandChar = pCommandChar;

	System::Diagnostics::Debug::WriteLine(
		System::String::Concat(
			L"debug::(callbackPointer)Send Command to UDK: ", 
			command));

	if (this->callbackPointer == NULL)
	{
		return;
	}

	try
	{
		this->callbackPointer(ATL::CW2A(pszpCommandChar));
	}
	catch(System::AccessViolationException^)
	{
		System::Diagnostics::Debug::WriteLine(
			System::String::Concat(
				L"debug::(callbackPointer) callbackPointer is not accessable (AccessViolationException)", 
				command));
	}
}

void CCommandInterface::Close()
{
	this->callbackPointer = NULL;
}
